/*
#    xfrmcalc - Scientific calculator based on Forms.
#    Copyright (C) 1996-1997  Martin Bartlett
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef FD_calculator_h_
#define FD_calculator_h_

/**** Callback routines ****/

extern void ExitProgram(FL_OBJECT *, long);
extern void ClearAll(FL_OBJECT *, long);
extern void EnterStackFunction(FL_OBJECT *, long);
extern void MemoryA(FL_OBJECT *, long);
extern void MemoryS(FL_OBJECT *, long);
extern void Memory(FL_OBJECT *, long);
extern void EnterDecimal(FL_OBJECT *, long);
extern void EnterComma(FL_OBJECT *, long);
extern void EnterNegate(FL_OBJECT *, long);
extern void EnterEqual(FL_OBJECT *, long);
extern void Backspace(FL_OBJECT *, long);
extern void Clear(FL_OBJECT *, long);
extern void EnterOpenParen(FL_OBJECT *, long);
extern void EnterCloseParen(FL_OBJECT *, long);
extern void CycleBase(FL_OBJECT *, long);
extern void CycleAngle(FL_OBJECT *, long);
extern void SetHex(FL_OBJECT *, long);
extern void SetOct(FL_OBJECT *, long);
extern void SetBin(FL_OBJECT *, long);
extern void SetDec(FL_OBJECT *, long);
extern void SetDeg(FL_OBJECT *, long);
extern void SetGra(FL_OBJECT *, long);
extern void SetRad(FL_OBJECT *, long);
extern void EnterDigit(FL_OBJECT *, long);
extern void EnterRecip(FL_OBJECT *, long);
extern void EnterSquare(FL_OBJECT *, long);
extern void EnterNotCmp(FL_OBJECT *, long);
extern void EnterPower(FL_OBJECT *, long);
extern void EnterLogr(FL_OBJECT *, long);
extern void EnterLogn(FL_OBJECT *, long);
extern void EnterPercent(FL_OBJECT *, long);
extern void EnterTrig(FL_OBJECT *, long);
extern void EnterCos(FL_OBJECT *, long);
extern void EnterTan(FL_OBJECT *, long);
extern void EnterHyper(FL_OBJECT *, long);
extern void EnterFactorial(FL_OBJECT *, long);
extern void EnterInt(FL_OBJECT *, long);
extern void CalcHelp(FL_OBJECT *, long);
extern void CutPasteDisplay(FL_OBJECT *, long);
extern void InsertConstant(FL_OBJECT *, long);
extern void EnterFunction(FL_OBJECT *, long);
extern int  raw_calc_callback(FL_FORM *, void *);


/**** Forms and Objects ****/

typedef struct {
	FL_FORM *calculator;
	FL_OBJECT *Quit;
	FL_OBJECT *ClearAll;
	FL_OBJECT *Multiply;
	FL_OBJECT *Divide;
	FL_OBJECT *MemoryClear;
	FL_OBJECT *MemoryRecall;
	FL_OBJECT *Plus;
	FL_OBJECT *Minus;
	FL_OBJECT *MemoryPlus;
	FL_OBJECT *Decimal;
	FL_OBJECT *Comma;
	FL_OBJECT *Negate;
	FL_OBJECT *Equals;
	FL_OBJECT *CLear;
	FL_OBJECT *CalcDisplay;
	FL_OBJECT *OpenParen;
	FL_OBJECT *CloseParen;
	FL_OBJECT *BaseButtons;
	FL_OBJECT *CheckHex;
	FL_OBJECT *OctSwitch;
	FL_OBJECT *BinSwitch;
	FL_OBJECT *DecSwitch;
	FL_OBJECT *AngleButtons;
	FL_OBJECT *DegSwitch;
	FL_OBJECT *GraSwitch;
	FL_OBJECT *RadSwitch;
	FL_OBJECT *HexDigits;
	FL_OBJECT *DigitB;
	FL_OBJECT *DigitA;
	FL_OBJECT *DigitC;
	FL_OBJECT *DigitF;
	FL_OBJECT *DigitE;
	FL_OBJECT *DigitD;
	FL_OBJECT *BinDigits;
	FL_OBJECT *DigitOne;
	FL_OBJECT *DigitZero;
	FL_OBJECT *OctDigits;
	FL_OBJECT *DigitSeven;
	FL_OBJECT *DigitFour;
	FL_OBJECT *DigitFive;
	FL_OBJECT *DigitSix;
	FL_OBJECT *DigitTwo;
	FL_OBJECT *DigitThree;
	FL_OBJECT *DecDigits;
	FL_OBJECT *DigitEight;
	FL_OBJECT *DigitNine;
	FL_OBJECT *Recip;
	FL_OBJECT *SqRoot;
	FL_OBJECT *Square;
	FL_OBJECT *NotCmp;
	FL_OBJECT *InvPower;
	FL_OBJECT *Power;
	FL_OBJECT *Log;
	FL_OBJECT *Logn;
	FL_OBJECT *Percent;
	FL_OBJECT *Sin;
	FL_OBJECT *Cos;
	FL_OBJECT *Tan;
	FL_OBJECT *Hyper;
	FL_OBJECT *Factorial;
	FL_OBJECT *Frac;
	FL_OBJECT *Int;
	FL_OBJECT *And;
	FL_OBJECT *Xor;
	FL_OBJECT *Or;
	FL_OBJECT *Lsh;
	FL_OBJECT *Rsh;
	FL_OBJECT *InvMod;
	FL_OBJECT *Mod;
	FL_OBJECT *Help;
	FL_OBJECT *Cut;
	FL_OBJECT *CalcHinput;
	void *vdata;
	long ldata;
} FD_calculator;

extern FD_calculator * create_form_calculator(void), *fd_calculator;

/*
 * Items used to include external things in the calculator
 */

#define STACK_SIZE	 100
#define BUF_SIZE	 1024
#define CALCAMNT	 long double
#define CALCFRMT     " %Lf "
#define PASTETIMEOUT 2000

typedef struct {
	int		args;
	char *	name;
} ext_func;

CALCAMNT *constants;		/* The array of constants    */
ext_func *ext_funcs;		/* External function details */

#endif /* FD_calculator_h_ */
