/*
#    xfrmcalc - Scientific calculator based on Forms.
#    Copyright (C) 1996-1997  Martin Bartlett
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "forms.h"
#include "calculator.h"
#include "calchelp.h"

FD_calculator *fd_calculator;
FD_calchelp   *fd_calchelp;
Display	      *fd_display;

int main(int argc, char *argv[])
{

   FL_IOPT flopt;    
   flopt.debug=0;
   flopt.borderWidth=-2;   

/*
 * In the event of starting from a console, fork so the prompt returns
 * immediately. This is not a full daemon, but it works
 */

/*   if (fork()) exit(0);
*/
   fl_set_defaults(FL_PDDebug| FL_PDBorderWidth/*|FL_PDButtonLabelSize*/,
                  &flopt); 

   fl_display = fl_initialize(&argc, argv, "XFCalc", 0, 0);

   fd_calculator = create_form_calculator();
   fd_calchelp   = create_form_calchelp();

   /* fill-in form initialization code */
   fl_set_goodies_font(FL_NORMAL_STYLE, FL_LARGE_SIZE);
   fl_deactivate_object(fd_calculator->HexDigits);
   fl_set_object_lcol(fd_calculator->HexDigits, FL_INACTIVE);
   fl_set_button(fd_calculator->DecSwitch, 1);
   fl_set_button(fd_calculator->DegSwitch, 1);
   fl_hide_object(fd_calculator->Comma);

   InitializeCalculator();

   /* load help */
   fl_load_browser(fd_calchelp->BrowseCalcHelp, XHELP);
   /* show the first form */
   fl_show_form(fd_calculator->calculator,FL_PLACE_SIZE,FL_FULLBORDER,"Xfrmcalc");
   fl_do_forms();
   return 0;
}
